/*
mmprob.c  Version 0.2.0 Print Mega Millions Odds
Copyright (C) 2002-2005  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/*
Subroutine call:
    	int select;
    	int megaball;
    	double odds;
    	double getmm();
    	odds = getmm(select,megaball);
*/

/* The mathematics for calculating the odds */
/* in this program is based on: */
/* Lincoln L. Chao */
/* Statistics for Management */
/* 2nd Edition */
/* Palo Alto: The Scientific Press, 1984 */
/* Chapter 4, Events and Probabilities */
/* Section 3, Computing Probability */
/* Example 4-13, Part 2 */

/* Lincoln L. Chao published this book while at */
/* California State University, Long Beach. */

#include <stdio.h>

int main()
   {
   double odds;
   double getmm(int select, int megaball);
   /******************************************************/
   /*                                                    */
   /* See the documentation in combo.c                   */
   /*                                                    */
   /* Odds for Grand Prize, match all 5 and mega ball    */
   /*                                                    */
   /*          C(5,5)  * C(1,1)                          */
   /*         ------------------                         */
   /*          C(52,5) * C(52,1)                         */
   /*                                                    */
   odds = getmm(5,1);
   printf("Prize          Odds\n");
   printf("5 1 %15.1f\n", odds);
   /******************************************************/
   /*                                                    */
   /* Odds for 2nd Prize, match all 5 and no mega ball   */
   /*                                                    */
   /*          C(5,5)  * C(51,1)                         */
   /*         ------------------                         */
   /*          C(52,5) * C(52,1)                         */
   /*                                                    */
   odds = getmm(5,0);
   printf("5 0 %15.1f\n", odds);
   /******************************************************/
   /*                                                    */
   /* Odds for matching 4 numbers and mega ball          */
   /*                                                    */
   /*          C(5,4) * C(47,1) * C(1,1)                 */
   /*         ---------------------------                */
   /*              C(52,5)      * C(52,1)                */
   /*                                                    */
   odds = getmm(4,1);
   printf("4 1 %15.1f\n", odds);
   /******************************************************/
   /*                                                    */
   /* Odds for matching 4 numbers and no mega ball       */
   /*                                                    */
   /*          C(5,4) * C(47,1) * C(51,1)                */
   /*         ---------------------------                */
   /*              C(52,5)      * C(52,1)                */
   /*                                                    */
   odds = getmm(4,0);
   printf("4 0 %15.1f\n", odds);
   /******************************************************/
   /*                                                    */
   /* Odds for matching 3 numbers and mega ball          */
   /*                                                    */
   /*          C(5,3) * C(47,2) * C(1,1)                 */
   /*         ---------------------------                */
   /*              C(52,5)      * C(52,1)                */
   /*                                                    */
   odds = getmm(3,1);
   printf("3 1 %15.1f\n", odds);
   /******************************************************/
   /*                                                    */
   /* Odds for matching 3 numbers and no mega ball       */
   /*                                                    */
   /*          C(5,3) * C(47,2) * C(51,1)                */
   /*         ---------------------------                */
   /*              C(52,5)      * C(52,1)                */
   /*                                                    */
   odds = getmm(3,0);
   printf("3 0 %15.1f\n", odds);
   /******************************************************/
   /*                                                    */
   /* Odds for matching 2 numbers and mega ball          */
   /*                                                    */
   /*          C(5,2) * C(47,3) * C(1,1)                 */
   /*         ---------------------------                */
   /*              C(52,5)      * C(52,1)                */
   /*                                                    */
   odds = getmm(2,1);
   printf("2 1 %15.1f\n", odds);
   /******************************************************/
   /*                                                    */
   /* Odds for matching 1 number and mega ball           */
   /*                                                    */
   /*          C(5,1) * C(47,4) * C(1,1)                 */
   /*         ---------------------------                */
   /*              C(52,5)      * C(52,1)                */
   /*                                                    */
   odds = getmm(1,1);
   printf("1 1 %15.1f\n", odds);
   /******************************************************/
   /*                                                    */
   /* Odds for matching 0 number and mega ball           */
   /*                                                    */
   /*          C(5,0) * C(47,5) * C(1,1)                 */
   /*         ---------------------------                */
   /*              C(52,5)      * C(52,1)                */
   /*                                                    */
   odds = getmm(0,1);
   printf("0 1 %15.1f\n", odds);
   return(0);
   } /* main */
